#include "usart.h"
#include <util/delay.h>
#include <avr/interrupt.h>
#include "CapacitiveSensor.h"

#define KEY_LEFT 'a'
#define KEY_RIGHT 'd'
#define KEY_DOWN 's'
#define KEY_JUMP 'n'
#define KEY_ACTION 'm'
#define NR_KEYS 5

char static key_valid[]  = {KEY_LEFT, KEY_RIGHT, KEY_DOWN, KEY_JUMP, KEY_ACTION};

volatile unsigned long currentMillis = 0;

CapacitiveSensor buttons[] = {
    CapacitiveSensor(1),
    CapacitiveSensor(2),
    CapacitiveSensor(3),
    CapacitiveSensor(4),
    CapacitiveSensor(6),
};

void listen_for_input()
{
    while(1)
    {
        for (int i = 0; i < NR_KEYS; i++) {
            while(buttons[i].capacitiveSensor(1) > 50)
            {
                USART0_transmit(key_valid[i]);
                _delay_ms(50);
            }
        }
        _delay_ms(5);
    }
}

// Debugging
void IO_init() 
{
        DDRD |= (1 << PD7);
}

int main()
{
    USART0_init(); 
    IO_init();
    listen_for_input();

    return 0;
}

