// Because the SendInput function is only supported in
// Windows 2000 and later, WINVER needs to be set as
// follows so that SendInput gets defined when windows.h
// is included below.
#define WINVER 0x0500

#define MAPPED_KEY_LEFT VK_LEFT
#define MAPPED_KEY_RIGHT VK_RIGHT
#define MAPPED_KEY_DOWN VK_DOWN
#define MAPPED_KEY_JUMP 'X'
#define MAPPED_KEY_ACTION 'Z'

#define KEY_LEFT 109
#define KEY_RIGHT 97
#define KEY_DOWN 100
#define KEY_JUMP 115
#define KEY_ACTION 110

#include <windows.h>
#include <stdio.h>

HANDLE hComm;
INPUT ip;
BYTE last_key_pressed;
BYTE key_pressed;
int pos, sleeping_time;

unsigned short static key_valid[]  = {KEY_LEFT, KEY_RIGHT, KEY_DOWN, KEY_JUMP, KEY_ACTION};
BYTE static mapped_key[] = {MAPPED_KEY_LEFT, MAPPED_KEY_RIGHT, MAPPED_KEY_DOWN, MAPPED_KEY_JUMP, MAPPED_KEY_ACTION};

void die(int condition, char *msg)
{
    if (condition) {
        CloseHandle(hComm);
        printf("Error at action: [%s]. Exiting\n", msg);
        exit(1);
    }
}

BYTE mapInputKeyToOutputKey(int unmmaped_key, int *pos)
{
    int i;
    for (i=0; i<5; i++) {
        if (key_valid[i] == unmmaped_key) {
            *pos = i;
            return mapped_key[i];
        }
    }

    return NULL;
}

void keyStroke(char char_key)
{
    BYTE key_pressed = mapInputKeyToOutputKey((int)char_key, &pos);
    sleeping_time = 50;
    if (pos == 3) {
        sleeping_time = 100;
        if (last_key_pressed == MAPPED_KEY_RIGHT) {
            keybd_event(last_key_pressed,0,0,0);
            keybd_event(key_pressed,0,0,0);
            Sleep(sleeping_time);
            keybd_event(key_pressed,0, KEYEVENTF_KEYUP,0);
            keybd_event(last_key_pressed,0, KEYEVENTF_KEYUP,0);
            return;
        }
    }
    keybd_event(key_pressed,0,0,0);
    Sleep(sleeping_time);
    keybd_event(key_pressed,0, KEYEVENTF_KEYUP,0);

}

int main()
{
    ip.type = INPUT_KEYBOARD;
    ip.ki.time = 0;
    ip.ki.dwExtraInfo = 0;

    char input[10];
    DWORD dwCommEvent;
    DWORD dwRead;
    hComm = CreateFile("COM7", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
    die(hComm == INVALID_HANDLE_VALUE, "create file");
    die(!SetCommMask(hComm, EV_RXCHAR), "set com mask");

    COMMTIMEOUTS timeouts;
    timeouts.ReadIntervalTimeout = 1;
    timeouts.ReadTotalTimeoutMultiplier = 1;
    timeouts.ReadTotalTimeoutConstant = 1;
    timeouts.WriteTotalTimeoutMultiplier = 1;
    timeouts.WriteTotalTimeoutConstant = 1;

    die(!SetCommTimeouts(hComm, &timeouts), "set com timeouts");
    printf("Waiting...\n");

    while (1) {
        if (WaitCommEvent(hComm, &dwCommEvent, NULL)) {
            if (ReadFile(hComm, input, 10, &dwRead, NULL)){
                keyStroke(input[0]);
                last_key_pressed = key_pressed;
            } else {
                die(1, "error on read");
            }
        } else {
            die(1, "error on wait");
        }
    }
    CloseHandle(hComm);
    printf("Exiting");
}